(* #load "graphics.cma";;
#load "unix.cma";;
*)
let color_to_rgb col = (col lsr 16),((col lsr 8) mod 256),(col mod 256);;

let moyenne mat = 
  let rR = ref 0 and gG =ref 0 and bB = ref 0 in
    for i= 0 to ( Array.length mat) -1 do
      for j = 0 to ( Array.length mat.(0) -1) do
	let a,b,c= color_to_rgb mat.(i).(j) in
	  (
	    rR:= !rR+a;
	    gG:=!gG+b;
	    bB:=!bB+c;
	  )
      done;done;
	  let n = ( Array.length mat)*( Array.length mat.(0)) in
	    (!rR/n,!gG/n,!bB/n);;

let corrige mat rR rRm gG gGm bB bBm = 
  for i= 0 to ( Array.length mat) -1 do
    for j = 0 to ( Array.length mat.(0) -1) do
      let a,b,c= color_to_rgb mat.(i).(j) in
	mat.(i).(j) <- 
	  (Graphics.rgb (min 255 ((a*(rRm+1))/(rR+1)))
	    (min 255 ((b*(gGm+1))/(gG+1)))
	    (min 255 ((c*(bBm+1))/(bB+1))))
    done;done;;

let cherche rR gG bB mat tab = 
  let iI = ref (Random.int ( Array.length mat))  and jJ = ref (Random.int  (Array.length mat.(0)))  and mM = ref 200000 in
    for i= 0 to ( Array.length mat) -1 do
      for j = 0 to ( Array.length mat.(0) -1) do
	let a,b,c= color_to_rgb mat.(i).(j) in
	  if (((a -rR)*(a-rR) +(b-gG)*(b-gG)+(c-bB)*(c-bB)) < !mM) && (tab.(i).(j)) then
	    (
	      iI:=i;jJ:=j;mM:=((a -rR)*(a-rR) +(b-gG)*(b-gG)+(c-bB)*(c-bB))
	    )
	  else ();
      done;done;(!iI,!jJ);;

let affdelta x y = print_int x;print_string " <> ";print_int y;print_newline ();;

(* liste des fichiers du repertoire s *)
let liste_repertoire s =
  let c = (Unix.opendir s)
  in
  let res = ref [] in
  let rec boucle () =
    try (res:=(Unix.readdir c)::!res;boucle ()) with _-> ((Unix.closedir c);!res)
  in boucle ();;

(* soit n et m de la chaine de caractres nxm *)

let netm s = 
  let rec indicex i = if (s.[i] = 'x') then i else (indicex (i+1))
  in (int_of_string (String.sub s 0 (indicex 0)),
     (int_of_string (String.sub s ((indicex 0)+1) ((String.length s) - (indicex 0)-1))));;

if ( Array.length Sys.argv) = 6 then
  
  (
    
    (* motif *)
    (function _ -> ()) (Sys.command ("convert  -type TrueColor \""^Sys.argv.(1)^"\" /tmp/__local.ppm"));
    let motif = Ppm.charge_PPM "/tmp/__local" in
    let haut_mot= ( Array.length motif) in
    let larg_mot= ( Array.length motif.(0)) in
    let fait_mot = (Array.make_matrix haut_mot larg_mot true) in
      (
	(* graphics__open_graph ((string_of_int hauteur)^"x"^(string_of_int largeur));
	   graphics__draw_image (make_image mat_pic) 0 0; *)
	
	(* cration de l'image *)
	(* Sys.argv.(2) est de la forme hautxlargeur avec haut et largeur entier
	   reprsentant la hauteur et la largeur des photos servant  faire l'image *)
	
	(* image  venir *)
	
	let rlarg,rhaut = (netm Sys.argv.(2)) in
	let haut_img = rhaut*haut_mot
	and larg_img = rlarg*larg_mot in
	  
	  (
	    print_string "haut_img: ";print_int haut_img;print_string " ";
	    print_string "larg_img: ";print_int larg_img;print_newline ();
	    let image = (Array.make_matrix haut_img larg_img Graphics.white)
	    in
	      (
		print_string "rhaut: ";print_int rhaut;print_string " ";
		print_string "rlarg: ";print_int rlarg;print_newline ();
		
		
		let liste_fic = liste_repertoire Sys.argv.(3) in
		  
		let traite s =
		  (
		    (function _ -> ()) (Sys.command ("rm  /tmp/__local.ppm"));
		    print_string ("Fichier "^Sys.argv.(3)^"/"^s);print_newline ();
		    (function _ -> ()) (Sys.command ("convert   -type TrueColor  \""^Sys.argv.(3)^"/"^s^"\" /tmp/__local.ppm"));
		    let mat_pic = Ppm.charge_PPM "/tmp/__local" in
		    let hauteur = ( Array.length mat_pic) and largeur = ( Array.length mat_pic.(0)) in
		      (*			let taille_image = ( Array.length mat_pic) * ( Array.length mat_pic.(0)) in
		      *)			  
		    let (a,b,c) = moyenne mat_pic
		    in
		      (
			
			print_string "R: ";print_int a;print_string " ";
			print_string "G: ";print_int b;print_string " ";
			print_string "B: ";print_int c;print_string "(";
			print_string "hauteur: ";print_int hauteur;print_string " ";
			print_string "largeur: ";print_int largeur;print_string ") -> ";
			
			
			let iI,jJ = (cherche a b c motif fait_mot) in
			  (
			    print_string "I: ";print_int iI;print_string ", J: ";print_int jJ;print_string " ";
			    let rRm,gGm,bBm = color_to_rgb motif.(iI).(jJ) in
			      (
				(function x -> ()) (corrige mat_pic a rRm b gGm c bBm);
				print_string "Rm: ";print_int rRm;print_string " ";
				print_string "Gm: ";print_int gGm;print_string " ";
				print_string "Bm: ";print_int bBm;print_newline ();
			      );
			      let dh = (Random.int hauteur) - (hauteur /2) 
			      and dl = (Random.int largeur) - (largeur /2) in

			      for i = 0 to hauteur -1 do
				for j = 0 to largeur - 1 do
				  (
				    (*			print_string "i: ";print_int (rhaut*iI + i);print_string " ";
							print_string "i: ";print_int (rlarg*jJ+j);print_newline ();
				    *)
				    try image.(rhaut*iI + i+dh).(rlarg*jJ+j+dl) <- mat_pic.(i).(j)
				      with vect_assign -> ();
				  )
				done;
				done;
				  fait_mot.(iI).(jJ) <- false;
			  );
			  1)
		  ) in
		let rec boucle x y = match x,y with
		  | 0,_ -> (
			Ppm.mat2PPM "/tmp/__Image" "F.B" ( Array.length image.(0)) ( Array.length image) image;
			(function _ -> ()) (Sys.command 
					     ("convert /tmp/__Image.ppm \"B_"^Sys.argv.(1)^"\"")));()
		  | n,(s::suite) when s.[0] = 'm' -> (print_int n;print_string " -> ";boucle (n-(traite s)) suite) 
		  | n,(s::suite) -> (boucle n  suite)
		  | n,[] -> (boucle n liste_fic)
		in (boucle (int_of_string Sys.argv.(4)) liste_fic)
		  
	      ))))
else if ( Array.length Sys.argv) = 5 then
  
  (
    
    (* motif *)
    (function _ -> ()) (Sys.command ("convert  -type TrueColor \""^Sys.argv.(1)^"\" /tmp/__local.ppm"));
    let motif = Ppm.charge_PPM "/tmp/__local" in
    let haut_mot= ( Array.length motif) in
    let larg_mot= ( Array.length motif.(0)) in
    let fait_mot = (Array.make_matrix haut_mot larg_mot true) in
      (
	(* graphics__open_graph ((string_of_int hauteur)^"x"^(string_of_int largeur));
	   graphics__draw_image (make_image mat_pic) 0 0; *)
	
	(* cration de l'image *)
	(* Sys.argv.(2) est de la forme hautxlargeur avec haut et largeur entier
	   reprsentant la hauteur et la largeur des photos servant  faire l'image *)
	
	(* image  venir *)
	
	let rlarg,rhaut = (netm Sys.argv.(2)) in
	let haut_img = rhaut*haut_mot
	and larg_img = rlarg*larg_mot in
	  
	  (
	    print_string "haut_img: ";print_int haut_img;print_string " ";
	    print_string "larg_img: ";print_int larg_img;print_newline ();
	    let image = (Array.make_matrix haut_img larg_img Graphics.white)
	    in
	      (
		print_string "rhaut: ";print_int rhaut;print_string " ";
		print_string "rlarg: ";print_int rlarg;print_newline ();
		
		
		let liste_fic = liste_repertoire Sys.argv.(3) in
		  
		let traite s =
		  (
		    (function _ -> ()) (Sys.command ("rm  /tmp/__local.ppm"));
		    print_string ("Fichier "^Sys.argv.(3)^"/"^s);print_newline ();
		    (function _ -> ()) (Sys.command ("convert   -type TrueColor  \""^Sys.argv.(3)^"/"^s^"\" /tmp/__local.ppm"));
		    let mat_pic = Ppm.charge_PPM "/tmp/__local" in
		    let hauteur = ( Array.length mat_pic) and largeur = ( Array.length mat_pic.(0)) in
		      if (hauteur = rhaut) && (largeur == rlarg) then 
(*			let taille_image = ( Array.length mat_pic) * ( Array.length mat_pic.(0)) in
*)			  
			let (a,b,c) = moyenne mat_pic
			in
			  (
			    
			    print_string "R: ";print_int a;print_string " ";
			    print_string "G: ";print_int b;print_string " ";
			    print_string "B: ";print_int c;print_string "(";
			    print_string "hauteur: ";print_int hauteur;print_string " ";
			    print_string "largeur: ";print_int largeur;print_string ") -> ";
			    
			    
			    let iI,jJ = (cherche a b c motif fait_mot) in
			      (
				print_string "I: ";print_int iI;print_string ", J: ";print_int jJ;print_string " ";
				let rRm,gGm,bBm = color_to_rgb motif.(iI).(jJ) in
				  (
				    (function x -> ()) (corrige mat_pic a rRm b gGm c bBm);
				    print_string "Rm: ";print_int rRm;print_string " ";
				    print_string "Gm: ";print_int gGm;print_string " ";
				    print_string "Bm: ";print_int bBm;print_newline ();
				  );
				  for i = 0 to rhaut -1 do
				    for j = 0 to rlarg - 1 do
				      (
					(*			print_string "i: ";print_int (rhaut*iI + i);print_string " ";
								print_string "i: ";print_int (rlarg*jJ+j);print_newline ();
					*)
					image.(rhaut*iI + i).(rlarg*jJ+j) <- mat_pic.(i).(j);
				      )
				    done;
				    done;
				      fait_mot.(iI).(jJ) <- false;
			      );
			      1) else 
			(if (hauteur <> rhaut) then (affdelta hauteur rhaut);
			 if (largeur <> rlarg) then (affdelta largeur rlarg);
			 0)
		  ) in
		let rec boucle x y = match x,y with
		| 0,_ -> (
		      Ppm.mat2PPM "/tmp/__Image" "F.B" ( Array.length image.(0)) ( Array.length image) image;
		      (function _ -> ()) (Sys.command 
					   ("convert /tmp/__Image.ppm \"B_"^Sys.argv.(1)^"\"")));()
		| n,(s::suite) when s.[0] = 'm' -> (print_int n;print_string " -> ";boucle (n-(traite s)) suite) 
		| n,(s::suite) -> (boucle n  suite)
		| n,[] -> (boucle n liste_fic)
		in (boucle (int_of_string Sys.argv.(4)) liste_fic)
		  
	      ))))
else
  (
    print_string "placeimage (Franois Boisson Septembre 2011)";print_newline ();
    print_string "";print_newline ();
    print_string "Fabrication d'un poster  partir d'un motif et d'une srie de photos.";print_newline ();
    print_string "Chaque pixel du motif est remplac par une photo dans le poster, la couleur";print_newline ();
    print_string "moyenne de la photo tant identique.";print_newline ();
    print_string "";print_newline ();
    print_string "Syntaxe: ";print_newline ();
    print_string "";print_newline ();
    print_string "placeimage motif taille_photos repertoire nombre";print_newline ();
    print_string "   ou";print_newline ();
    print_string "placeimage motif taille_photos repertoire nombre alea";print_newline ();
    print_string "";print_newline ();
    print_string "motif: nom complet de l'image reprsentant le motif";print_newline ();
    print_string "taille_photos: taille d'une photo au format largeurxhauteur (ex: 64x80)";print_newline ();
    print_string "repertoire: repertoire contenant les photos dont le nom commence par 'm'";print_newline ();
    print_string "nombre: nombre de photos  mettre dans le poster";print_newline ();
    print_string "alea: Si un 6ieme argument est donne, les photos non alignes";print_newline ();
    print_string "";print_newline ();
    print_string "Remarque:";print_newline ();
    print_string "- Le poster est sauv sous le nom B_<motif>";print_newline ();
    print_string "- Les photos non conformes aux dimensions sont cartes.";print_newline ();
    print_string "- Le repertoire est parcouru, chaque photo est mise  l'endroit le plus";print_newline ();
    print_string "adquat. Le repertoire est reparcouru jusqu' ce que les n photos soient places.";print_newline ();
  );;




