(* Fichier ppm.ml : transport des images au format PPM 
                    attention: c'est du binary encoded ! *)

(* #load "graphics.cma";; *)

let nom_sans_extension nom ext =
    
        let n = String.length nom
    
        and n' = String.length ext
    
        in
    
                if n > n' && (("." ^ ext)  =
                             (String.sub nom (n-n'-1) (n'+1)))
        
                then String.sub nom 0 (n-n'-1)
    
                else nom ;;


let lit_octet canal_in = 
    (* try *) 
    input_byte canal_in
    (* with End_of_file -> begin 

                        seek_in canal_in ((pos_in canal_in)+1);
                        26
                        end *)
    ;;


let lit_graphics_rgb canal_in = 
    let r=lit_octet canal_in and g=lit_octet canal_in 
                             and b=lit_octet canal_in
    in ((Graphics.rgb r g b):int);;

let lit_nombre_ascii canal_in c = 
    let s=ref 0 in 
    (
    while ((!c) = ' ' or (!c) = char_of_int(9) or (!c) = char_of_int(10)
                      or (!c) = char_of_int(13)) 
          do c:=input_char canal_in done;
    if ((!c) < '0' or (!c) > '9') then failwith "Nombre en ASCII attendu";
    while ((!c) >= '0' && (!c) <= '9' ) 
          do  s:=10*(!s)+(int_of_char(!c)- int_of_char('0'));
              c:=input_char canal_in
          done;
    (!s)
    );;

let apres_fin_ligne canal_in c = 
    (
    while (!c) <> (char_of_int 10) do c:=input_char canal_in done;
    c:=input_char canal_in;
    (!c)
    );;

    
let charge_PPM fichier_ppm =
    
     let nom = (nom_sans_extension fichier_ppm "ppm") ^ ".ppm" in
    
     let canal_in = open_in_bin nom in
    
     let c=ref '0' in 
     (
     if (input_char canal_in) <> 'P' or (input_char canal_in) <> '6' 
             then failwith "Erreur: pas un fichier .PPM";
     c:=apres_fin_ligne (canal_in) (ref (input_char canal_in));
     if (!c)='#' then c:=apres_fin_ligne canal_in c;
     let largeur = lit_nombre_ascii canal_in c in 
     let hauteur = lit_nombre_ascii canal_in c in
    
     let champ = lit_nombre_ascii canal_in c in
     let image = Array.make_matrix hauteur largeur 0
    
     in
    
        (
        if champ <> 255 then failwith "Pas le bon format sur 8 bits.";
        (* c:=apres_fin_ligne canal_in c;*)
        for i=0 to hauteur-1 do
        
        for j=0 to largeur -1 do
            
        image.(i).(j) <- lit_graphics_rgb canal_in      
        done
            done ;
        close_in canal_in;
        image 
        )
      );;

let char_for_read = String.make 1;; 

let ascii = fun chiffre -> char_for_read(char_of_int (chiffre + int_of_char '0'));;
    
let int2ascii = fun a -> let s=ref "" and x=ref a in 
    (
    while (!x)>0 do 
           s:=(ascii((!x) mod 10))^(!s);x:=(!x)/10 
                 done;
    (!s)
    );;

let ecrit_couleurs canal_out = fun coul -> let r=255*256*256 and g=255*256 and b=255 in 
    (output_byte canal_out ((coul land r) lsr 16);
     output_byte canal_out ((coul land g) lsr 8);
     output_byte canal_out (coul land b));;
    
let mat2PPM fichier_ppm comment larg haut mat =
    
     let nom = (nom_sans_extension fichier_ppm "ppm") ^ ".ppm" in
    
     let canal_out = open_out_bin nom in
    
     (
     output_char canal_out 'P';
     output_char canal_out '6';
     output_char canal_out (char_of_int(10));
     output_char canal_out '#';
     output_string canal_out comment;    
     output_char canal_out (char_of_int(10));
     output_string canal_out (int2ascii larg);
     output_char canal_out ' ';
     output_string canal_out (int2ascii haut);
     output_char canal_out (char_of_int(10));
     output_string canal_out (int2ascii 255);
     output_char canal_out (char_of_int(10));
     for i=0 to haut-1 do
        
        for j=0 to larg -1 do
            
            ecrit_couleurs canal_out (mat.(i).(j))
                              done
                           done ;
     output_char canal_out (char_of_int(26));
     close_out canal_out;
     );;
     
(* let mat_pic = charge_PPM "arabian";;   
open_graph "";;
draw_image(make_image mat_pic) 0 0;; *)
        
